VERSION 5.00
Begin VB.Form frmVis3 
   AutoRedraw      =   -1  'True
   BackColor       =   &H00404040&
   Caption         =   "rumint: Parallel Coordinate Plot"
   ClientHeight    =   6045
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5700
   Icon            =   "frmVis3.frx":0000
   LinkTopic       =   "Form1"
   MinButton       =   0   'False
   ScaleHeight     =   6045
   ScaleWidth      =   5700
   StartUpPosition =   2  'CenterScreen
   Begin VB.VScrollBar scrNumAxes 
      Height          =   375
      Left            =   1560
      Max             =   2
      Min             =   19
      TabIndex        =   4
      Top             =   3960
      Value           =   2
      Width           =   375
   End
   Begin VB.ComboBox comboAxis 
      Height          =   315
      Index           =   0
      Left            =   2040
      TabIndex        =   1
      Text            =   "Combo1"
      Top             =   3600
      Visible         =   0   'False
      Width           =   1215
   End
   Begin VB.PictureBox picGraph 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H00000000&
      BorderStyle     =   0  'None
      FillStyle       =   0  'Solid
      ForeColor       =   &H80000008&
      Height          =   3495
      Left            =   0
      ScaleHeight     =   233
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   273
      TabIndex        =   0
      Top             =   0
      Width           =   4095
   End
   Begin VB.Label lblNumAxes 
      Alignment       =   2  'Center
      BackColor       =   &H00C0C0C0&
      Caption         =   "2"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   1200
      TabIndex        =   3
      Top             =   3960
      Width           =   375
   End
   Begin VB.Label lblNumAxesCaption 
      BackStyle       =   0  'Transparent
      Caption         =   "Number of Axes"
      Height          =   255
      Left            =   0
      TabIndex        =   2
      Top             =   3960
      Width           =   1215
   End
End
Attribute VB_Name = "frmVis3"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'RUMINT, A PVR for network traffic
'Copyright (C) 2005 Greg Conti

'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 2
'of the License, or (at your option) any later version.

'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Option Explicit

Dim axis(1 To 19) As Long 'used for placing things on the form
Dim scaledAxis(1 To 19) As Long 'used for placing things in the picgraph
Dim numColumns As Long 'number of vertical axes in graph
Dim plotColor As ColorConstants
  
'add mouseover information

'********************** Graphics ****************************



Public Sub plotThumbnail(ByVal packetNumber As Long)
  Dim octet1 As Long
  Dim octet2 As Long
  Dim scaledValue(0 To 1) As Long
  Dim unscaledValue(0 To 1) As Long
  
  'source IP (left axis)
  octet1 = modLibrary.getSourceIP(packetNumber, 1)
  octet2 = modLibrary.getSourceIP(packetNumber, 2)
  unscaledValue(0) = (octet1 * 256) + octet2 'beware weird overflow error
  scaledValue(0) = scaleRange(unscaledValue(0), 65536, frmMain.picVis(3).ScaleHeight)
  
  'combined TCP and UPD dest Port (right axis)
  unscaledValue(1) = modLibrary.getTCPdestPort(packetNumber)
  If unscaledValue(1) = 0 Then unscaledValue(1) = modLibrary.getUDPdestPort(packetNumber)
  scaledValue(1) = scaleRange(unscaledValue(1), 65536, frmMain.picVis(3).ScaleHeight)
  
  'Debug.Print scaledValue(0) & "  "; scaledValue(1)
  
  frmMain.picVis(3).Line (0, scaledValue(0))-(frmMain.picVis(3).ScaleWidth, scaledValue(1)), vbGreen

End Sub

Public Sub Plot(ByVal packetNumber As Long)
  Dim counter As Long
  Dim scaledValue(1 To 19) As Long
  Dim unscaledValue(1 To 19) As Long
  Dim label(1 To 19) As String
  Dim octet1 As Long
  Dim octet2 As Long
    
  plotColor = modEncodings.SetPlotColor(modLibrary.getPacketIPtransportProtocol(packetNumber))
  
  For counter = 1 To numColumns
    If comboAxis(counter).ListIndex = 0 Then
      unscaledValue(counter) = modLibrary.getPacketLen(packetNumber) 'packetLength
      label(counter) = unscaledValue(counter)
      scaledValue(counter) = scaleRange(unscaledValue(counter), 1518, picGraph.ScaleHeight)
    End If
    
    If comboAxis(counter).ListIndex = 1 Then 'Ethertype
      unscaledValue(counter) = modLibrary.getEtherType(packetNumber)
      'Debug.Print (unscaledValue(counter))
      label(counter) = modLibrary.getEtherTypeString(packetNumber)
      scaledValue(counter) = scaleRange(unscaledValue(counter), 65536, picGraph.ScaleHeight)
    End If
        
    If comboAxis(counter).ListIndex = 2 Then 'IP version
      unscaledValue(counter) = modLibrary.getIPVersion(packetNumber)
      label(counter) = unscaledValue(counter)
      scaledValue(counter) = scaleRange(unscaledValue(counter), 16, picGraph.ScaleHeight)
    End If
    
    If comboAxis(counter).ListIndex = 3 Then 'IP header len
      unscaledValue(counter) = modLibrary.getIPHeaderLen(packetNumber)
      label(counter) = unscaledValue(counter)
      scaledValue(counter) = scaleRange(unscaledValue(counter), 16, picGraph.ScaleHeight)
    End If
    
    If comboAxis(counter).ListIndex = 4 Then 'IP differentiated services
      unscaledValue(counter) = modLibrary.getDifferentiatedServices(packetNumber)
      'Debug.Print (unscaledValue(counter))
      label(counter) = unscaledValue(counter)
      scaledValue(counter) = scaleRange(unscaledValue(counter), 256, picGraph.ScaleHeight)
    End If
    
    If comboAxis(counter).ListIndex = 5 Then 'IP total length
      unscaledValue(counter) = modLibrary.getIPtotalLength(packetNumber)
      'Debug.Print (unscaledValue(counter))
      label(counter) = unscaledValue(counter)
      scaledValue(counter) = scaleRange(unscaledValue(counter), 65536, picGraph.ScaleHeight)
    End If
    
    If comboAxis(counter).ListIndex = 6 Then 'IP identification
      unscaledValue(counter) = modLibrary.getIPidentification(packetNumber)
      'Debug.Print (unscaledValue(counter))
      label(counter) = unscaledValue(counter)
      scaledValue(counter) = scaleRange(unscaledValue(counter), 65536, picGraph.ScaleHeight)
    End If
    
    If comboAxis(counter).ListIndex = 7 Then 'IP flags
      If modLibrary.getIPflagsR(packetNumber) Then label(counter) = label(counter) & "reserved"
      If modLibrary.getIPflagsDF(packetNumber) Then label(counter) = label(counter) & "DF"
      If modLibrary.getIPflagsMF(packetNumber) Then label(counter) = label(counter) & "MF"
      unscaledValue(counter) = unscaledValue(counter)
      scaledValue(counter) = scaleRange(unscaledValue(counter), 8, picGraph.ScaleHeight)
    End If
    
    If comboAxis(counter).ListIndex = 8 Then 'IP fragment offset
      unscaledValue(counter) = modLibrary.getIPfragmentoffset(packetNumber)
      'Debug.Print (unscaledValue(counter))
      label(counter) = unscaledValue(counter)
      scaledValue(counter) = scaleRange(unscaledValue(counter), 8192, picGraph.ScaleHeight)
    End If
    
    If comboAxis(counter).ListIndex = 9 Then
      unscaledValue(counter) = modLibrary.getIPTTL(packetNumber) 'IP TTL
      label(counter) = unscaledValue(counter)
      scaledValue(counter) = scaleRange(unscaledValue(counter), 256, picGraph.ScaleHeight)
    End If
        
    If comboAxis(counter).ListIndex = 10 Then
      unscaledValue(counter) = modLibrary.getPacketIPtransportProtocol(packetNumber) 'IP transport protocol field
      'label(counter) = unscaledValue(counter)
      label(counter) = modLookUp.lookupIPprotocol(modLibrary.getPacketIPtransportProtocol(packetNumber))
      scaledValue(counter) = scaleRange(unscaledValue(counter), 256, picGraph.ScaleHeight)
    End If
    
    If comboAxis(counter).ListIndex = 11 Then 'IP header checksum
      unscaledValue(counter) = modLibrary.getIPheaderchecksum(packetNumber)
      'Debug.Print (unscaledValue(counter))
      label(counter) = unscaledValue(counter)
      scaledValue(counter) = scaleRange(unscaledValue(counter), 65536, picGraph.ScaleHeight)
    End If
    
    If comboAxis(counter).ListIndex = 12 Then 'source IP
      label(counter) = modLibrary.getSourceIPstring(packetNumber)
      octet1 = modLibrary.getSourceIP(packetNumber, 1) 'unscaledValue(counter)
      octet2 = modLibrary.getSourceIP(packetNumber, 2)
      unscaledValue(counter) = (octet1 * 256) + octet2 'beware weird overflow error
      'unscaledValue(counter) = (((octet1 / 2) * 2) * 256) + octet2
      scaledValue(counter) = scaleRange(unscaledValue(counter), 65536, picGraph.ScaleHeight)
    End If
    
    If comboAxis(counter).ListIndex = 13 Then 'dest IP
      label(counter) = modLibrary.getDestIPstring(packetNumber)
      octet1 = modLibrary.getDestIP(packetNumber, 1)
      octet2 = modLibrary.getDestIP(packetNumber, 2)
      unscaledValue(counter) = (octet1 * 256) + octet2
      scaledValue(counter) = scaleRange(unscaledValue(counter), 65536, picGraph.ScaleHeight)
    End If
    
    If comboAxis(counter).ListIndex = 14 Then 'TCP Source Port
      unscaledValue(counter) = modLibrary.getTCPsourcePort(packetNumber)
      'Debug.Print (unscaledValue(counter))
      label(counter) = unscaledValue(counter)
      'scaledValue(counter) = scaleRange(unscaledValue(counter), gTCPSRCrange, picGraph.ScaleHeight)
      scaledValue(counter) = modLibrary.scaleRange(unscaledValue(counter), gTCPSRCPortMin, gTCPSRCPortMax, picGraph.ScaleHeight)
    End If
    
    If comboAxis(counter).ListIndex = 15 Then 'TCP Destination Port
      unscaledValue(counter) = modLibrary.getTCPdestPort(packetNumber)
      'Debug.Print (unscaledValue(counter))
      label(counter) = unscaledValue(counter)
      'scaledValue(counter) = scaleRange(unscaledValue(counter), gTCPDSTrange, picGraph.ScaleHeight)
      scaledValue(counter) = modLibrary.scaleRange(unscaledValue(counter), gTCPDSTPortMin, gTCPDSTPortMax, picGraph.ScaleHeight)
    End If
    
    If comboAxis(counter).ListIndex = 16 Then 'TCP Sequence Number
      label(counter) = modLibrary.getTCPsequencenumberString(packetNumber)
      octet1 = modLibrary.getTCPsequencenumber(packetNumber, 1)
      octet2 = modLibrary.getTCPsequencenumber(packetNumber, 2)
      unscaledValue(counter) = (octet1 * 256) + octet2
      scaledValue(counter) = scaleRange(unscaledValue(counter), 65536, picGraph.ScaleHeight)
    End If
    
    If comboAxis(counter).ListIndex = 17 Then 'UDP Source Port
      unscaledValue(counter) = modLibrary.getUDPsourcePort(packetNumber)
      'Debug.Print (unscaledValue(counter))
      label(counter) = unscaledValue(counter)
      'scaledValue(counter) = scaleRange(unscaledValue(counter), gUDPSRCrange, picGraph.ScaleHeight)
      scaledValue(counter) = modLibrary.scaleRange(unscaledValue(counter), gUDPSRCPortMin, gUDPSRCPortMax, picGraph.ScaleHeight)
    End If
    If comboAxis(counter).ListIndex = 18 Then 'UDP Destination Port
      unscaledValue(counter) = modLibrary.getUDPdestPort(packetNumber)
      'Debug.Print (unscaledValue(counter))
      label(counter) = unscaledValue(counter)
      'scaledValue(counter) = scaleRange(unscaledValue(counter), gUDPDSTrange, picGraph.ScaleHeight)
      scaledValue(counter) = modLibrary.scaleRange(unscaledValue(counter), gUDPDSTPortMin, gUDPDSTPortMax, picGraph.ScaleHeight)
    End If
    
  Next
  
  For counter = 1 To numColumns - 1
    If Hex(modLibrary.getEtherType(packetNumber)) = 800 Then
        Call PlotAxis(counter, scaledValue(counter), scaledValue(counter + 1), label(counter), label(counter + 1))
    Else
       If (comboAxis(counter).ListIndex = 0 And (comboAxis(counter + 1).ListIndex = 1 Or comboAxis(counter + 1).ListIndex = 0)) Or _
       (comboAxis(counter).ListIndex = 1 And (comboAxis(counter + 1).ListIndex = 0 Or comboAxis(counter + 1).ListIndex = 1)) Then
          Call PlotAxis(counter, scaledValue(counter), scaledValue(counter + 1), label(counter), label(counter + 1))
       Else
         If (comboAxis(counter).ListIndex = 0 Or comboAxis(counter).ListIndex = 1) And _
            (comboAxis(counter + 1).ListIndex <> 0 And comboAxis(counter + 1).ListIndex <> 1) Then
           Call PlotPoint(counter, scaledValue(counter), label(counter))
         Else
           If (comboAxis(counter + 1).ListIndex = 0 Or comboAxis(counter + 1).ListIndex = 1) _
            And (comboAxis(counter).ListIndex <> 0 And comboAxis(counter).ListIndex <> 1) Then
             Call PlotPoint(counter + 1, scaledValue(counter + 1), label(counter + 1))
           End If
         End If
        End If
    End If
  Next counter
  
End Sub

Public Function scaleRange(ByVal actualValue As Variant, ByVal maxRange As Variant, ByVal displayValue As Variant) As Variant
    If displayValue <= 0 Then
      scaleRange = 0 'returns a zero to avoid division by zero
    Else
      scaleRange = displayValue - ((actualValue / maxRange) * displayValue) 'start from top
    End If
End Function
'Private Function scaleRange(ByVal actualValue as Long, ByVal maxRange as Long) as Long
 ' If maxRange <= 0 Then
  '  scaleRange = 0 'returns a zero to avoid division by zero
  'Else
   ' scaleRange = picGraph.ScaleHeight - ((actualValue / 1518) * maxRange)
  'End If
'End Function

Private Sub PlotPoint(axis As Long, ByVal scaledValue As Long, ByVal unscaledValue As String)
 picGraph.PSet (scaledAxis(axis), scaledValue), plotColor
 picGraph.ForeColor = vbWhite
 picGraph.CurrentX = scaledAxis(axis)
 picGraph.CurrentY = scaledValue
 picGraph.Print unscaledValue
End Sub


Private Sub PlotAxis(axis As Long, ByVal scaledValue1 As Long, ByVal scaledValue2 As Long, _
                     ByVal unscaledValue1 As String, ByVal unscaledValue2 As String)
  
  Dim counter As Long
    
   picGraph.Line (scaledAxis(axis), scaledValue1)-(scaledAxis(axis + 1), scaledValue2), plotColor 'vbGreen
  
  For counter = 1 To 0 Step -1
    If counter = 1 Then picGraph.ForeColor = RGB(64, 64, 64) Else picGraph.ForeColor = vbWhite
    
    picGraph.CurrentX = scaledAxis(axis) + counter
    If (scaledValue1 + counter) < (picGraph.ScaleHeight - picGraph.TextHeight("A")) Then
      picGraph.CurrentY = scaledValue1 + counter
    Else
      picGraph.CurrentY = scaledValue1 + counter - picGraph.TextHeight("A")
    End If
    picGraph.Print unscaledValue1
    If axis + 1 < numColumns Then
      picGraph.CurrentX = scaledAxis(axis + 1) + counter
    Else
      picGraph.CurrentX = scaledAxis(axis + 1) - (picGraph.TextWidth("A") * Len(unscaledValue2)) + counter
    End If
    
    If (scaledValue2 + counter) < (picGraph.ScaleHeight - picGraph.TextHeight("A")) Then
      picGraph.CurrentY = scaledValue2 + counter
    Else
      picGraph.CurrentY = scaledValue2 + counter - picGraph.TextHeight("A")
    End If
    
    'picGraph.CurrentY = scaledValue2
    picGraph.Print unscaledValue2
  Next counter
End Sub


'************************ Form ******************************
Private Sub Form_Load()
 Dim counter As Long
 For counter = 1 To 19 'create a number of hidden combobox objects for axis control
    Load comboAxis(counter)
    With comboAxis(counter)
    
      'external information
      .AddItem ("packet length")
      
      'layer 2
      .AddItem ("Ethertype")
      
      'layer 3
         'IP
         .AddItem ("IP Version")
         .AddItem ("IP Header Len")
         .AddItem ("IP Diff Services")
         .AddItem ("IP Total Length")
         .AddItem ("IP Identification")
         .AddItem ("IP Flags")
         .AddItem ("IP Fragment Offset")
         .AddItem ("TTL")
         .AddItem ("IP Transport Protocol")
         .AddItem ("IP Header Checksum")
         .AddItem ("Source IP")
         .AddItem ("Dest IP")
           
      'layer 4
         'TCP
           .AddItem ("TCP Source Port")
           .AddItem ("TCP Dest Port")
           .AddItem ("TCP Sequence Number")
         'UDP
           .AddItem ("UDP Source Port")
           .AddItem ("UDP Dest Port")
      
      '.ListIndex = counter - 1 'make this more intelligent in the future
      .ListIndex = modPreferences.parallelComboDefault(counter) 'modPrefences
      
    End With
 Next counter
End Sub

Private Sub Form_Resize()
  Dim meHeight As Long
  Dim counter As Long
    
  'put in code to prevent too small a window size
  If Me.Height < 3000 Then Me.Height = 3000
  If Me.Width < 2000 Then Me.Width = 2000
  meHeight = Me.Height 'remember form scale mode should be set for twips
  picGraph.Cls
  picGraph.Left = 0
  picGraph.Top = 0
  picGraph.Height = Me.Height - 1300
  picGraph.Width = Me.Width
  
  For counter = 1 To 19
    With comboAxis(counter)
      .Visible = False
    End With
  Next counter
  
  CalcColumns 'places comboboxes as well
  
  scrNumAxes.Top = comboAxis(1).Top + comboAxis(1).Height + 150
  lblNumAxes.Top = comboAxis(1).Top + comboAxis(1).Height + 150
  lblNumAxesCaption.Top = comboAxis(1).Top + comboAxis(1).Height + _
    (lblNumAxes.Height / 2) - (lblNumAxesCaption.Height / 2) + 150
End Sub

Private Sub CalcColumns()
  Dim counter As Long
  
  numColumns = scrNumAxes.value
  axis(1) = 0 'leftmost axis
  scaledAxis(1) = 0
  For counter = 2 To numColumns - 1
    axis(counter) = ((counter - 1) / (numColumns - 1)) * picGraph.Width
    scaledAxis(counter) = ((counter - 1) / (numColumns - 1)) * picGraph.ScaleWidth
  Next counter
  axis(numColumns) = picGraph.Width 'rightmost axis
  scaledAxis(numColumns) = picGraph.ScaleWidth
  
  For counter = 1 To numColumns
    With comboAxis(counter)
      If counter = 1 Then
        .Left = 0
      Else
        If counter = numColumns Then
          .Left = picGraph.Width - comboAxis(counter).Width - 100
        Else
          .Left = axis(counter) - (comboAxis(counter).Width / 2)
          picGraph.Line ((scaledAxis(counter)), 0)- _
                  ((scaledAxis(counter)), picGraph.Height), RGB(64, 64, 64)
        End If
      End If
      .Top = picGraph.Height + 50
      .Visible = True
    End With
  Next counter
End Sub

Private Sub Form_Unload(Cancel As Integer)
  Call modLibrary.UnloadedForm(Me, frmFilters.vis3)
  Dim counter As Long
  For counter = 1 To numColumns
    modPreferences.parallelComboDefault(counter) = comboAxis(counter).ListIndex 'modpreferences
  Next
End Sub

'******************** GUI **********************
Public Sub ScreenShot(systemTime As String)
  SavePicture picGraph.Image, App.Path & "\" & systemTime & "_parallelcoord.bmp"
End Sub

Public Sub clear()
  picGraph.Cls
  frmMain.picVis(3).Cls
End Sub

Private Sub scrNumAxes_Change()
  lblNumAxes.Caption = scrNumAxes.value
  Form_Resize
End Sub
